#ifdef GL_ES
//precision mediump float;
//precision mediump int;
precision highp float;
precision highp int;
#endif

////////////////////////////////////////////////////////////////////////////////
uniform sampler2D sampler;
varying vec2 fragment_uv;

////////////////////////////////////////////////////////////////////////////////
//uniform float near_plane;
//uniform float far_plane;
float near_plane= 0.125;
float far_plane= 384.0;
float LinearizeDepth(float depth)
{
	float z = depth * 2.0 - 1.0; // Back to NDC 
	return (2.0 * near_plane * far_plane) / (far_plane + near_plane - z * (far_plane - near_plane));
}

////////////////////////////////////////////////////////////////////////////////
void main() {
	//gl_FragColor = vec4(color, 1.0) + vec4(0.8f, 0.0f, 0.0f, 0.0f);
	//gl_FragColor = vec4(0.8f, 0.0f, 0.0f, 1.0f);

	//vec3 color = texture2D(sampler, fragment_uv);
	//if (color == vec3(1.0, 0.0, 1.0)) {
	//    discard;
	//}
	//gl_FragColor = vec4(color, 1.0f);
	//gl_FragColor = vec4(vec3(color.r), 1.0f);

	float depthValue = texture(sampler, fragment_uv).r;
	//gl_FragColor = vec4(vec3(LinearizeDepth(depthValue) / far_plane), 1.0); // perspective
	gl_FragColor = vec4(vec3(depthValue), 1.0); // orthographic
}
